#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// Controlla che non sia un numero
int checkchar(char c) {
  return ( (c<'0') || (c>'9') );
}


// Ritorna il primo token che cambia da numero a carattere, da carattere
// a numero, oppure prima di un punto '.'
char *get_dot_token(char **s) {
  char *r;
  int i, tipo;
  if (s==NULL) return NULL;
  if (*s==NULL) return NULL;
  r = strdup(*s);
  tipo = checkchar(r[0]);
  for (i=0; (r!=NULL) && (r[i]!=0); i++ ) {
    if (r[i]=='.') {
      r[i]=0;
      *s = (*s) + i + 1;
      return r;
    }
    if ( tipo != checkchar(r[i]) ) {
      r[i]=0;
      *s = (*s) + i;
      return r;
    }
  }
  if (r[i]==0) *s=NULL;
  return r;  
}


// Confronta le versioni di due nomi nella forma: $NOME_$VERSIONE
// dove versione e' nella forma: x.y.z
int request_version( char *arg1, char *arg2 ) {
  char *s1, *s2, *t1, *t2;
  int i;
  
  s1 = strdup(arg1);
  s2 = strdup(arg2);
  while (1) {
    //printf("check_version (1): %s vs %s \n", s1, s2 );
    t1 = get_dot_token(&s1);
    t2 = get_dot_token(&s2);
    //printf("check_version (2): %s -- %s \n", t1, t2 );
    if ( ( t1==NULL ) || (t2==NULL) ) {
      if ((t1==NULL)&&(t2!=NULL)) return -1;
      if ((t1!=NULL)&&(t2==NULL)) return +1;
      //printf("check_version    : NULLI ! \n" );
      return 0;
    }      
    if ( 0 == checkchar(t1[0]) ) {
      i = atoi(t1) - atoi(t2);
    } else {
      i = strcmp(t1,t2);
    }
    if (i!=0) {
      //printf("check_version    : Differenza = %i \n", i );
      return i;
    }
  }
  return 0;
}
